gtkmm: Gtk::SizeGroup Class Reference

gtkmm 3.4.0

- Main Page
- Related Pages
- Modules
- Namespaces
- Classes

- Class List
- Class Index
- Class Hierarchy
- Class Members

Public Member Functions | Static Public Member Functions | Protected Member Functions | Related Functions
Gtk::SizeGroup Class Reference

Gtk::SizeGroup provides a mechanism for grouping a number of widgets together so they all request the same amount of space. More...

Inheritance diagram for Gtk::SizeGroup:
[legend]

List of all members.

## Public Member Functions
virtual | ~SizeGroup ()
GtkSizeGroup* | gobj ()
| Provides access to the underlying C GObject.
const GtkSizeGroup* | gobj () const
| Provides access to the underlying C GObject.
GtkSizeGroup* | gobj_copy ()
| Provides access to the underlying C instance. The caller is responsible for unrefing it. Use when directly setting fields in structs.
void | set_mode (SizeGroupMode mode)
| Sets the Gtk::SizeGroupMode of the size group.
SizeGroupMode | get_mode () const
| Gets the current mode of the size group.
void | set_ignore_hidden (bool ignore_hidden=true)
| Sets whether unmapped widgets should be ignored when calculating the size.
bool | get_ignore_hidden () const
| Returns if invisible widgets are ignored when calculating the size.
void | add_widget (Widget& widget)
| Adds a widget to a Gtk::SizeGroup.
void | remove_widget (Widget& widget)
| Removes a widget from a Gtk::SizeGroup.
std::vector< Widget* > | get_widgets ()
| Returns the list of widgets associated with size_group.
std::vector< const Widget* > | get_widgets () const
| Returns the list of widgets associated with size_group.
Glib::PropertyProxy < SizeGroupMode > | property_mode ()
| The directions in which the size group affects the requested sizes of its component widgets.
Glib::PropertyProxy_ReadOnly < SizeGroupMode > | property_mode () const
| The directions in which the size group affects the requested sizes of its component widgets.
Glib::PropertyProxy< bool > | property_ignore_hidden ()
| If TRUE, unmapped widgets are ignored when determining the size of the group.
Glib::PropertyProxy_ReadOnly < bool > | property_ignore_hidden () const
| If TRUE, unmapped widgets are ignored when determining the size of the group.
## Static Public Member Functions
static Glib::RefPtr< SizeGroup > | create (SizeGroupMode mode)
## Protected Member Functions
| SizeGroup (SizeGroupMode mode)
## Related Functions
(Note that these are not member functions.)
Glib::RefPtr< Gtk::SizeGroup > | wrap (GtkSizeGroup* object, bool take_copy=false)
| A Glib::wrap() method for this object.

## Detailed Description

Gtk::SizeGroup provides a mechanism for grouping a number of widgets together so they all request the same amount of space.

This is typically useful when you want a column of widgets to have the same size, but you can't use a Gtk::Table widget.

In detail, the size requested for each widget in a Gtk::SizeGroup is the maximum of the sizes that would have been requested for each widget in the size group if they were not in the size group. The mode of the size group (see set_mode()) determines whether this applies to the horizontal size, the vertical size, or both sizes.

Note that size groups only affect the amount of space requested, not the size that the widgets finally receive. If you want the widgets in a GtkSizeGroup to actually be the same size, you need to pack them in such a way that they get the size they request and not more. For example, if you are packing your widgets into a table, you would not include the Gtk::FILL flag.

Widgets can be part of multiple size groups; GTK+ will compute the horizontal size of a widget from the horizontal requisition of all widgets that can be reached from the widget by a chain of size groups of type Gtk::SIZE_GROUP_HORIZONTAL or Gtk::SIZE_GROUP_BOTH, and the vertical size from the vertical requisition of all widgets that can be reached from the widget by a chain of size groups of type Gtk::SIZE_GROUP_VERTICAL or Gtk::SIZE_GROUP_BOTH.

## Constructor & Destructor Documentation

virtual Gtk::SizeGroup::~SizeGroup | ( |  | ) | `[virtual]`

Gtk::SizeGroup::SizeGroup | ( | SizeGroupMode | mode | ) | `[explicit, protected]`

## Member Function Documentation

void Gtk::SizeGroup::add_widget | ( | Widget& | widget | ) |

Adds a widget to a Gtk::SizeGroup.

In the future, the requisition of the widget will be determined as the maximum of its requisition and the requisition of the other widgets in the size group. Whether this applies horizontally, vertically, or in both directions depends on the mode of the size group. See set_mode().

When the widget is destroyed or no longer referenced elsewhere, it will be removed from the size group.

Parameters:

  widget | The Gtk::Widget to add.

static Glib::RefPtr<SizeGroup> Gtk::SizeGroup::create | ( | SizeGroupMode | mode | ) | `[static]`

bool Gtk::SizeGroup::get_ignore_hidden | ( |  | ) | const

Returns if invisible widgets are ignored when calculating the size.

Since gtkmm 2.8:

Returns:
  `true` if invisible widgets are ignored.

SizeGroupMode Gtk::SizeGroup::get_mode | ( |  | ) | const

Gets the current mode of the size group.

See set_mode().

Returns:
  The current mode of the size group.

std::vector<Widget*> Gtk::SizeGroup::get_widgets | ( |  | ) |

Returns the list of widgets associated with size_group.

Since gtkmm 2.10:

Returns:
  A SList of widgets. The list is owned by GTK+ and should not be modified.

std::vector<const Widget*> Gtk::SizeGroup::get_widgets | ( |  | ) | const

Returns the list of widgets associated with size_group.

Since gtkmm 2.10:

Returns:
  A SList of widgets. The list is owned by GTK+ and should not be modified.

GtkSizeGroup* Gtk::SizeGroup::gobj | ( |  | ) | `[inline]`

Provides access to the underlying C GObject.

Reimplemented from Gtk::Buildable.

const GtkSizeGroup* Gtk::SizeGroup::gobj | ( |  | ) | const`[inline]`

Provides access to the underlying C GObject.

Reimplemented from Gtk::Buildable.

GtkSizeGroup* Gtk::SizeGroup::gobj_copy | ( |  | ) |

Provides access to the underlying C instance. The caller is responsible for unrefing it. Use when directly setting fields in structs.

Glib::PropertyProxy< bool > Gtk::SizeGroup::property_ignore_hidden | ( |  | ) |

If TRUE, unmapped widgets are ignored when determining the size of the group.

You rarely need to use properties because there are get_ and set_ methods for almost all of them.

Returns:
  A PropertyProxy that allows you to get or set the property of the value, or receive notification when the value of the property changes.

Glib::PropertyProxy_ReadOnly< bool > Gtk::SizeGroup::property_ignore_hidden | ( |  | ) | const

If TRUE, unmapped widgets are ignored when determining the size of the group.

You rarely need to use properties because there are get_ and set_ methods for almost all of them.

Returns:
  A PropertyProxy that allows you to get or set the property of the value, or receive notification when the value of the property changes.

Glib::PropertyProxy< SizeGroupMode > Gtk::SizeGroup::property_mode | ( |  | ) |

The directions in which the size group affects the requested sizes of its component widgets.

You rarely need to use properties because there are get_ and set_ methods for almost all of them.

Returns:
  A PropertyProxy that allows you to get or set the property of the value, or receive notification when the value of the property changes.

Glib::PropertyProxy_ReadOnly< SizeGroupMode > Gtk::SizeGroup::property_mode | ( |  | ) | const

The directions in which the size group affects the requested sizes of its component widgets.

You rarely need to use properties because there are get_ and set_ methods for almost all of them.

Returns:
  A PropertyProxy that allows you to get or set the property of the value, or receive notification when the value of the property changes.

void Gtk::SizeGroup::remove_widget | ( | Widget& | widget | ) |

Removes a widget from a Gtk::SizeGroup.

Parameters:

  widget | The Gtk::Widget to remove.

void Gtk::SizeGroup::set_ignore_hidden | ( | bool | ignore_hidden = `true` | ) |

Sets whether unmapped widgets should be ignored when calculating the size.

Since gtkmm 2.8:

Parameters:

  ignore_hidden | Whether unmapped widgets should be ignored when calculating the size.

void Gtk::SizeGroup::set_mode | ( | SizeGroupMode | mode | ) |

Sets the Gtk::SizeGroupMode of the size group.

The mode of the size group determines whether the widgets in the size group should all have the same horizontal requisition (Gtk::SIZE_GROUP_HORIZONTAL) all have the same vertical requisition (Gtk::SIZE_GROUP_VERTICAL), or should all have the same requisition in both directions (Gtk::SIZE_GROUP_BOTH).

Parameters:

  mode | The mode to set for the size group.

## Friends And Related Function Documentation

Glib::RefPtr< Gtk::SizeGroup > wrap | ( | GtkSizeGroup * | object,
|  | bool | take_copy = `false`
| ) |  | `[related]`

A Glib::wrap() method for this object.

Parameters:

  object | The C instance.
  take_copy | False if the result should take ownership of the C instance. True if it should take a new copy or ref.

Returns:
  A C++ instance that wraps this C instance.

The documentation for this class was generated from the following file:

- gtkmm/sizegroup.h